// iPaq 3D engine  -  Janurary 2001  -  The Phantom
// Minimal 3D engine for Handhelds
// ------------------------------------------------

#include "engine.h"
#include "rasterize.h"
#ifdef _WIN32_WCE
#include "easyce.h"
#else
#include "ptc.h"
#endif

#ifdef _WIN32_WCE
void main()
{
	PIXEL* pixels = new PIXEL[320 * 240];
#else
int APIENTRY WinMain( HINSTANCE a, HINSTANCE b, LPSTR c, int d )
{
	Format format( 16, 31 << 11, 63 << 5, 31 );
	Console console;
	console.option( "Windowed output" );
	console.open( "iPaq 3D Engine", 320, 240, format );
	Surface surface( 320, 240, format );
#endif
	ARasterizer* rast = new ARasterizer();
	AMesh* mesh = new AMesh();
	int rot = 0;
#ifdef _WIN32_WCE
	mesh->load3ds( L"Program Files\\EasyCE\\bull.3ds" );
	while (!clicked())
	{
#else
	mesh->load3ds( "bull.3ds" );
	while (!console.key())
	{
		PIXEL* pixels = (PIXEL*)surface.lock();
#endif
		rast->setbuffer( pixels );
		rast->nextframe();
		AMatrix mat;
		mat.identity();
		mat.rotate( IFP(192), rot, 0 );
		mat.translate( 0, IFP(222), IFP(1000) );
		mesh->transform( mat );
		mesh->draw( rast, mat.getz() );
		rot += FP_ONE; if (rot > IFP(256)) rot = 0;
#ifdef _WIN32_WCE
		PIXEL* dest = (PIXEL*)GXBeginDraw();
		char temp[20] = "               ";
		int fps = (int)(1000.0f / msecs());
		resettimer();
		itoa( fps, temp );
		temp[strlen( temp )] = 32;
		itoa( mesh->polies(), temp + 3 );
		temp[strlen( temp )] = 32;
		print( "fps:  ,      polygons", 10, 230, 65535, (unsigned long*)pixels );
		print( temp, 40, 230, 65535, (unsigned long*)pixels );
		rast->update( dest );
		GXEndDraw();
		update( false );
	}
#else
		surface.unlock();
		surface.copy( console );
		console.update();
	}
	return 0;
#endif
}

// ------------------------------------------------
// EOF